<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Http\Requests;
use Session;

use ReportRecord as ReportsHelper;
use App\ReportRecord as Report;
use App\Jobs\ReportRequest as ReportRequestJob;
use App\ReportRequest; 



class ReportRecordsController extends Controller
{

    public function index(Request $request)
    {
        if(!$request->has('excel')){
            $query = ReportsHelper::getReportRecordsQuery($request->all());
            $status = trans('clients.status');
            
            if(\Auth::user()->role == 'manager'){
                //quitamos SIN GERENCIA ASIGNADA DEL ARREGLO
                unset($status[0]);
            }

            if(\Auth::user()->role == 'executive'){
                //quitamos SIN GERENCIA ASGINADA DEL ARREGLO Y SIN EJECUTIVO ASIGNADO TAMBIEN
                unset($status[0]);
                unset($status[10]);
            }

            unset($status[\App\Client::ESTATUS_FINADO]);
            unset($status[\App\Client::ESTATUS_PENSIONADO]);
            unset($status[\App\Client::ESTATUS_CEDIDO]);
            $result = $query->paginate(50);
            $result->where('kind', Report::USER_ASSIGN)->load('newUser');
            $result->where('kind', Report::MANAGEMENT_ASSIGN)->load('newManagement');
            $result->where('kind', Report::USER_UNASSIGN)->load('oldUser');
            $result->where('kind', Report::MANAGEMENT_UNASSIGN)->load('oldManagement');
            return view('reports.index')
                ->withReports($result)
                ->withStatus($status);   

        }else{
            
            $report_request = new ReportRequest(['user_id' => auth()->user()->id,'status' => 1]);
            $report_request->save();
            $request = array_merge($request->all());

            try {
                
                $this->dispatch(new ReportRequestJob($report_request,$request));

                return redirect()
                    ->action('ReportRequestsController@index')
                    ->withSuccess('Se ha creado la solicitud del reporte, esta puede tardar varios minutos en procesarse.');

            } catch (\Exception $e) {
                return redirect()->back()->withErrors($e);
            }
        }
    }
}
